﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.InteropServices;
using System.Security.Permissions;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace MMDeviceTestingCS
{
    internal class Program
    {
        static uint S_OK = 0;
        static uint S_FALSE = 1;

        [STAThread]
        static void Main(string[] args)
        {
            uint hr = NativeMethods.CoInitialize(IntPtr.Zero);
            if(hr == S_OK || hr == S_FALSE)
            {
                Guid CLSID_MMDeviceEnumerator = new Guid("BCDE0395-E52F-467C-8E3D-C4579291692E");
                Guid IID_IMMDeviceEnumerator = new Guid("A95664D2-9614-4F35-A746-DE8DB63617E6");
                IntPtr ptrDeviceEnumerator;
                hr = NativeMethods.CoCreateInstance(CLSID_MMDeviceEnumerator, IntPtr.Zero, CLSCTX.CLSCTX_ALL, IID_IMMDeviceEnumerator, out ptrDeviceEnumerator);
                if(hr == S_OK)
                {
                    IMMDeviceEnumerator iDeviceEnumerator = (IMMDeviceEnumerator)Marshal.GetObjectForIUnknown(ptrDeviceEnumerator);
                    IMMDeviceCollection iDeviceCollection;
                    hr = iDeviceEnumerator.EnumAudioEndpoint(EDataFlow.eRender, DeviceState.DEVICE_STATE_ACTIVE, out iDeviceCollection);
                    uint deviceCount = 0;
                    if(hr == S_OK)
                    {
                        hr = iDeviceCollection.GetCount(ref deviceCount);
                        if (hr == S_OK)
                        {
                            for(uint i = 0; i < deviceCount; i++)
                            {
                                IMMDevice device;
                                hr = iDeviceCollection.Item(i, out device);
                                if (hr == S_OK)
                                {
                                    IPropertyStore iPropertyStore;
                                    hr = device.OpenPropertyStore(0, out iPropertyStore);
                                    if (hr == S_OK)
                                    {
                                        PropVariant deviceNamePropVariant = new PropVariant();
                                        PropertyKey propertyKey = new PropertyKey();
                                        propertyKey.pid = 14;
                                        propertyKey.fmtid = new Guid("A45C254E-DF1C-4EFD-8020-67D146A850E0");
                                        hr = iPropertyStore.GetValue(propertyKey, out deviceNamePropVariant);
                                        if (hr == S_OK)
                                        {
                                            string deviceName = Marshal.PtrToStringUni(deviceNamePropVariant.pwszVal);
                                            Console.WriteLine(deviceName);
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
            hr = NativeMethods.CoUninitialize();
            Console.ReadKey();
        }
    }
}
